/*
 * Author: Jake G
 * Date: 2024
 * filename: LedController.c
 * description: Abstract LED interface and control.
 */

#ifndef __AVR_ATtiny404__
#define __AVR_ATtiny404__
#endif

#include "LedController.h"
#include "avr/io.h"

#define PA_B1 (1 << 2)
#define PA_B2 (1 << 3)
#define PA_B3 (1 << 6)
#define PA_B4 (1 << 7)

#define BITS_IN_BYTE (1 << 2) | (1 << 3) | (1 << 6) | (1 << 7)

#define HALF_BYTE_BM

LedByte LedController_New(uint8_t *port)
{
    LedByte led_byte;
    for (int i = 0; i < 8; i++)
    {
        led_byte.leds[i].pin_num = 1;
        led_byte.leds[i].state   = false;
        led_byte.leds[i].port    = port;
    }
    return led_byte;
}

void LedController_ShowByte(LedByte *led_byte, uint8_t byte)
{
}

void LedControler_ClearByte(LedByte *led_byte)
{
}

void LedController_SetHigh(Led *led)
{
    *led->port |= (1 << led->pin_num);
    led->state = true;
    return;
}

void LedController_SetLow(Led *led)
{
    *led->port &= ~(1 << led->pin_num);
    led->state = false;
    return;
}
